<?php
namespace HCM\SST\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;

class EpiRepository {

    protected  $connection;
    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection    = $connection;
        $this->entityManager = $entityManager;
    }

    public function gethistoricoepi($nrorg,$nrepi) {
        $query = <<<SQL
        SELECT * 
        FROM SST_HISTORICOEPI 
        WHERE NRORG = :p_nrorg
        AND NREPI = :p_nrepi
SQL;
        $params = array(
            "p_nrorg" => $nrorg,
            "p_nrepi" => $nrepi
        );
        return $this->connection->fetchAll($query,$params);
    }
    
    public function getitemperfilepi($nrorg,$nrepi) {
        $query = <<<SQL
        SELECT * 
        FROM SST_ITEMPERFILEPI 
        WHERE NRORG = :p_nrorg
        AND NREPI = :p_nrepi
SQL;
        $params = array(
            "p_nrorg" => $nrorg,
            "p_nrepi" => $nrepi
        );
        return $this->connection->fetchAll($query,$params);
    }
    
    public function getriscoepi($nrorg,$nrepi) {
        $query = <<<SQL
        SELECT * 
        FROM SST_RISCOEPI 
        WHERE NRORG = :p_nrorg
        AND NREPI = :p_nrepi
SQL;
        $params = array(
            "p_nrorg" => $nrorg,
            "p_nrepi" => $nrepi
        );
        return $this->connection->fetchAll($query,$params);
    }
    
    public function getFoto($row){
        $query = "SELECT NRANEXO,
                         NRORG,
                         NRPARCNEGOCIO,
                         NMANEXO,
                         DSREFERENCIA,
                         IDTYPE,
                         DSURL,
                         DTINCLUSAO,
                         DTULTATU,
                         CDOPERINCLUSAO,
                         CDOPERULTATU,
                         IDFOTO,
                         NRCATEGDOCUMENTO,
                         NRTIPODOCUMENTO,
                         CASE
                             WHEN INSTR(AN.DSPATH, 'pebbian.com') > 0 THEN NULL
                             ELSE AN.DSPATH
                         END DSPATH
                    FROM GPE_ANEXOS AN
                   WHERE ( NRORG = :P_NRORG_PADRAO OR NRORG = :P_NRORG )
                         AND NRPARCNEGOCIO = :P_NRPARCNEGOCIO
                         AND IDFOTO = :P_IDFOTO";
        
        $params = array('P_NRORG_PADRAO'  => $row['NRORG_PADRAO'],
                        'P_NRORG'         => $row['NRORG'],
                        'P_IDFOTO'        => 'S',
                        'P_NRPARCNEGOCIO' => $row['NREPI']);
        
        return $this->connection->fetchAssoc($query,$params);
    }
} 

