/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PRESENTE                                                */
/* Tabela : PRESENTE                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 18/08/2009 Isabella Guimares                                                   */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_PRESENTE
BEFORE INSERT OR UPDATE OR DELETE
ON PRESENTE FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATU := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (:OLD.CDPRESENTE <> :NEW.CDPRESENTE) OR
          (:OLD.NMPRESENTE <> :NEW.NMPRESENTE) THEN
           :NEW.DTULTATU := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('PRESENTE','', 'CDPRESENTE='||:OLD.CDPRESENTE||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE PRESENTE MODIFY DTULTATU DEFAULT SYSDATE
/
