CREATE OR REPLACE TRIGGER LOG_OPL_CONSSOLOL
AFTER DELETE OR INSERT
ON CONSSOLOL FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(1500);
  V_CDFILLOGOPER VARCHAR2(4);
  V_ITPESQ       VARCHAR2(80);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_IDTIPOOPER   := '';
   V_CDFILLOGOPER := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF INSERTING THEN
      V_DESC   :=        'Num. Consol. '          ||''  || NVL(:NEW.NRSEQUCONSOL,'')       ||'  '  ||
                         'Op. Logstico '         ||''  || NVL(:NEW.CDFILIOPELOG,'')       ||'  '  ||
                         'Dt. In. Consol. '       ||''  || NVL(:NEW.DTINICONSSOLOL,'')     ||'  '  ||
                         'Dt. Fin. Consol. '      ||''  || NVL(:NEW.DTFINCONSSOLOL,'')     ||'  '  ||
                         'Sit. Consol. '          ||''  || NVL(:NEW.IDSITUCONSSOL,'')      ||'  '  ||
                         'Dt. Consolidao '      ||''  || NVL(:NEW.DTCONSSOLOL,'')        ||'  '  ||
                         'Operador '              ||''  || NVL(:NEW.CDOPERADOR,'')         ||'  '  ||
                         'Dt. Concluso Cons. '   ||''  || NVL(:NEW.DTCONCONSSOLOL,'')     ||'  '  ||
                         'Priorizar Emb. Est. '   ||''  || NVL(:NEW.IDEMBESTCONSOL,'')     ||'  '  ||
                         'Prod. Inicial '         ||''  || NVL(:NEW.CDPRODINICONSOL,'')    ||'  '  ||
                         'Prod. Final '           ||''  || NVL(:NEW.CDPRODFINCONSOL,'')    ||'  '  ||
                         'Consid. Prev. Consumo ' ||''  || NVL(:NEW.IDCONSPREVCONOL,'');

      V_ITPESQ       := :NEW.NRSEQUCONSOL;
      V_CDFILLOGOPER := :NEW.CDFILIOPELOG;
      V_IDTIPOOPER   := '1';
   ELSE
      IF DELETING THEN
         V_DESC  :=      'Num. Consol. '          ||''  || NVL(:OLD.NRSEQUCONSOL,'')       ||'  '  ||
                         'Op. Logstico '         ||''  || NVL(:OLD.CDFILIOPELOG,'')       ||'  '  ||
                         'Dt. In. Consol. '       ||''  || NVL(:OLD.DTINICONSSOLOL,'')     ||'  '  ||
                         'Dt. Fin. Consol. '      ||''  || NVL(:OLD.DTFINCONSSOLOL,'')     ||'  '  ||
                         'Sit. Consol. '          ||''  || NVL(:OLD.IDSITUCONSSOL,'')      ||'  '  ||
                         'Dt. Consolidao '      ||''  || NVL(:OLD.DTCONSSOLOL,'')        ||'  '  ||
                         'Operador '              ||''  || NVL(:OLD.CDOPERADOR,'')         ||'  '  ||
                         'Dt. Consumo '           ||''  || NVL(:OLD.DTCONCONSSOLOL,'')     ||'  '  ||
                         'Priorizar Emb. Est. '   ||''  || NVL(:OLD.IDEMBESTCONSOL,'')     ||'  '  ||
                         'Prod. Inicial '         ||''  || NVL(:OLD.CDPRODINICONSOL,'')    ||'  '  ||
                         'Prod. Final '           ||''  || NVL(:OLD.CDPRODFINCONSOL,'')    ||'  '  ||
                         'Consid. Prev. Consumo ' ||''  || NVL(:OLD.IDCONSPREVCONOL,'');

         V_ITPESQ         := :OLD.NRSEQUCONSOL;
         V_CDFILLOGOPER   := :OLD.CDFILIOPELOG;
         V_IDTIPOOPER     := '3';
      END IF;
   END IF;
   IF (V_DESC IS NOT NULL)   THEN
      V_DESC := SUBSTR(V_DESC, 1, 300);
      INSERT INTO LOGOPERA
         (NMTABELA,
          DTOPERACAO,
          NMRESPOPER,
          IDTIPOOPER,
          DSOPERACAO,
          CDPESQITEM,
          DSRDMUSUOPER,
          DSENDUSUOPER,
          DSNMUSUOPER,
          DSMETUSUOPER,
          CDORESPOPER,
          CDFILLOGOPER)
      VALUES
         ('CONSSOLOL',
          SYSDATE,
          NVL(V_NMOPERADOR,' '),
          V_IDTIPOOPER,
          V_DESC,
          V_ITPESQ,
          V_DSSERVERRDM,
          V_DSREMOTEADDR,
          V_DSREMOTEHOST,
          V_DSSERVMETHOD,
          V_DSREMOTEOPER,
          V_CDFILLOGOPER);
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_OPL_CONSSOLOL','5.40.xxx'); END;
/