/*
@c:\web_407\cli\src\cli\coan\sql\004_limpaestoq.sql
*/
CREATE OR REPLACE PROCEDURE ALTERA_EVOL_ESTOQUE(
   P_CDFILIAL     IN VARCHAR2,
   P_DTIMPLANT    IN DATE)

AS
   V_QTESTOQDIA      NUMBER;
   V_VRESTOQDIA      NUMBER;
   V_VRESTOQBRUT     NUMBER;
   V_NRSEQUITEM      NUMBER;
   V_NRLANCESTQ      VARCHAR2(20);
   V_COUNT           NUMBER;
BEGIN
   V_NRSEQUITEM := 1;
   V_COUNT      := 0;

   FOR C_PRODUTO IN (
      SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE,    CDPRODUTO
      FROM POSESTDIA P
      WHERE CDFILIAL   = P_CDFILIAL AND
            QTESTOQDIA <> 0                 AND
            DTPOSIESTQ = (SELECT MAX(DTPOSIESTQ)
                          FROM POSESTDIA
                          WHERE CDFILIAL     = P.CDFILIAL     AND
                                CDALMOXARIFE = P.CDALMOXARIFE AND
                                CDLOCALESTOQ = P.CDLOCALESTOQ AND
                                NRLOTEESTQ   = P.NRLOTEESTQ   AND
                                NRSUBLOTE    = P.NRSUBLOTE    AND
                                CDPRODUTO    = P.CDPRODUTO    AND
                                DTPOSIESTQ   <= P_DTIMPLANT)
      MINUS
      SELECT I.CDFILIMOVI,I.CDALMOXARIFE, I.CDLOCALESTOQ, I.NRLOTEESTQ, I.NRSUBLOTE, I.CDPRODUTO
      FROM ITLANCTOEST I
      WHERE I.CDFILIMOVI  = P_CDFILIAL      AND
            I.IDTIPOMOVI  = '0'             AND
            I.DTLANCMOVI  = P_DTIMPLANT     AND
            I.IDEVOLESTOQ = 'S') LOOP

         SELECT QTESTOQDIA, VRESTOQDIA, VRESTOQBRUT
         INTO V_QTESTOQDIA, V_VRESTOQDIA, V_VRESTOQBRUT
         FROM POSESTDIA P
         WHERE CDFILIAL       = C_PRODUTO.CDFILIAL     AND
               CDALMOXARIFE   = C_PRODUTO.CDALMOXARIFE AND
               CDLOCALESTOQ   = C_PRODUTO.CDLOCALESTOQ AND
               NRLOTEESTQ     = C_PRODUTO.NRLOTEESTQ   AND
               NRSUBLOTE      = C_PRODUTO.NRSUBLOTE    AND
               CDPRODUTO      = C_PRODUTO.CDPRODUTO    AND
               QTESTOQDIA     <> 0                     AND
               DTPOSIESTQ = (SELECT MAX(DTPOSIESTQ)
                             FROM POSESTDIA
                             WHERE CDFILIAL     = P.CDFILIAL     AND
                                   CDALMOXARIFE = P.CDALMOXARIFE AND
                                   CDLOCALESTOQ = P.CDLOCALESTOQ AND
                                   NRLOTEESTQ   = P.NRLOTEESTQ   AND
                                   NRSUBLOTE    = P.NRSUBLOTE    AND
                                   CDPRODUTO    = P.CDPRODUTO    AND
                                   DTPOSIESTQ   <= P_DTIMPLANT);

         IF V_NRSEQUITEM = 1 THEN
            NOVO_CODIGO('LANCTOEST' || C_PRODUTO.CDFILIAL, V_NRLANCESTQ);

            INSERT INTO LANCTOESTOQ
            (CDFILIAL,NRLANCESTQ,CDOPERADOR,IDTPLANCTO,DTLANCESTQ,CDFILIMOVI, DSLANCESTQ)
            VALUES
            (C_PRODUTO.CDFILIAL, SUBSTR(V_NRLANCESTQ,11,10), '000000000999', '0', P_DTIMPLANT, C_PRODUTO.CDFILIAL, 'Atualizao Implantao Web');
         END IF;
         INSERT INTO ITLANCTOEST
            (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO,  QTTOTLANCTO, VRUNILANCTO, VRTOTLANCTO, IDTIPOMOVI,
             DTLANCMOVI, IDORDEMCLC, CDPRODMOVI, QTLANCTOEST, VRLANCTOBRUT, VRLANCTOEST, CDFILIMOVI, IDEVOLESTOQ,
             CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE)
         VALUES
            (C_PRODUTO.CDFILIAL, SUBSTR(V_NRLANCESTQ,11,10), LPAD(TO_CHAR(V_NRSEQUITEM), 4, '0'), C_PRODUTO.CDPRODUTO,
             V_QTESTOQDIA, (V_VRESTOQDIA/V_QTESTOQDIA), V_VRESTOQDIA, '0', P_DTIMPLANT, '0', C_PRODUTO.CDPRODUTO,
             V_QTESTOQDIA, V_VRESTOQBRUT, V_VRESTOQDIA, C_PRODUTO.CDFILIAL, 'S', C_PRODUTO.CDALMOXARIFE, C_PRODUTO.CDLOCALESTOQ,
             C_PRODUTO.NRLOTEESTQ, C_PRODUTO.NRSUBLOTE);

         V_NRSEQUITEM := V_NRSEQUITEM + 1;

         IF V_COUNT > 500 THEN
            COMMIT;
            V_COUNT := 0;
         END IF;
         V_COUNT := V_COUNT + 1;

         DELETE FROM POSESTDIA
         WHERE CDFILIAL       = C_PRODUTO.CDFILIAL     AND
               CDALMOXARIFE   = C_PRODUTO.CDALMOXARIFE AND
               CDLOCALESTOQ   = C_PRODUTO.CDLOCALESTOQ AND
               NRLOTEESTQ     = C_PRODUTO.NRLOTEESTQ   AND
               NRSUBLOTE      = C_PRODUTO.NRSUBLOTE    AND
               CDPRODUTO      = C_PRODUTO.CDPRODUTO    AND
               DTPOSIESTQ      <= P_DTIMPLANT;

         DELETE FROM POSESTCONS
         WHERE CDFILIAL       = C_PRODUTO.CDFILIAL     AND
               CDPRODUTO      = C_PRODUTO.CDPRODUTO    AND
               DTPOSESTCON     <= P_DTIMPLANT;
   END LOOP;

   UPDATE ITLANCTOEST
   SET IDEVOLESTOQ = 'N'
   WHERE CDFILIMOVI = P_CDFILIAL    AND
         DTLANCMOVI < P_DTIMPLANT;


   COMMIT;
END;
/